// +----------------------------------------------------------------------------------------+ //
// |    .-._______                           XARD777                          _______.-.    | //
// |---( )_)______)                 Knowledge of the ancients                (______(_( )---| //
// |  (    ()___)                              \/                             (___()    )  | //
// |       ()__)                              (o o)                             (__()       | //
// |--(___()_)__________________________oOOo___(_)___oOOo_________________________(_()___)--| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// |                 File:     -Profit-Loss BB.mq4                                              | //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// |                                                               [BILLION DOLLAR PROJECT] | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //


extern double posY            = -230.00;
extern double posX            = -15.0;
extern int    Corner=1;
extern int    Window=0;
extern color  Warna_Text       = Snow;
extern color  Text_Order_Sell  = C'204,0,0';
extern color  Text_Order_Buy   = DarkGreen;
extern color  Negative_Font    = C'204,0,0';
extern color  Positive_Font    = C'0,168,0';
extern string NamaFont        = "Arial Bold";
extern int    TotalFont       = 14;
extern int    Font            = 11;
extern int    acc_Font        = 11;
extern int    Acc_digits      = 11;


// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //


int x = NULL;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
  {
//---- indicators
//----
   return(0);
  }

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit()
  {
//----
   int    idx;

   if(x != NULL) {
      for(idx = 60; idx>x; idx--) {
         ObjectDelete("Panel242-"+idx);
         ObjectDelete("Panel243-"+idx);
         ObjectDelete("PL"+idx);
         
      }
         
      ObjectDelete("Panel241");
      ObjectDelete("Panel242");
      ObjectDelete("Panel2420"+idx);
      ObjectDelete("Panel243");     
      ObjectDelete("h");      
      ObjectDelete("Total1");
      ObjectDelete("Total2");
      ObjectDelete("Panel244");
      ObjectDelete("Total3");

   }
   
    

//----
   return(0);
  }
  
void DisplayText(string objname, string text, int fontsize, color clr, double C, double X, double Y, string font)
{
   ObjectDelete(objname);
   ObjectCreate(objname, OBJ_LABEL, Window, 0,0);
   ObjectSetText(objname, text, fontsize, font, clr);
   ObjectSet(objname, OBJPROP_CORNER, Corner);
   ObjectSet(objname, OBJPROP_XDISTANCE, X+posX);
   ObjectSet(objname, OBJPROP_YDISTANCE, Y+posY);
}
  
// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start()
  {
 
   int    counted_bars=IndicatorCounted();
   int    j,k;
   int    idx;
   string text;
   double PL;
   double total;
   double EQ;
   
//----
         if(x != NULL) {
            for(idx =60; idx>x; idx--) {
               ObjectDelete("Panel241"+idx);
               ObjectDelete("Panel242"+idx);
               ObjectDelete("Panel243"+idx);
               ObjectDelete("Panel2420"+idx);
   //Added these to fix the non delete problem            
         ObjectDelete("Panel242-"+idx);
         ObjectDelete("Panel243-"+idx);
         ObjectDelete("PL"+idx);
            }
            
            ObjectDelete("Total1");
            ObjectDelete("Total2");
// added these to fix the non delete problem
                  ObjectDelete("Panel241");
        ObjectDelete("Panel242");
        ObjectDelete("Panel2420"+idx);
        ObjectDelete("Panel243");     
        ObjectDelete("h");      
        ObjectDelete("Panel244");
        ObjectDelete("Total3");
            
         }
            
         text = "";
         j= -60;
         total = 0;
         
         EQ= AccountEquity();
         DisplayText("Panel244","$ " +DoubleToStr(EQ , 2.0)+"",Acc_digits, DarkGray, 0, 30, Font-26 - j * 18.4, "Arial");
         DisplayText("Total3","acc", acc_Font, DarkGray, 0, 120, Font-26 - j * 18.4 ,"Arial"); 
        
         for (int i = OrdersTotal()-1 ; i >= 0; i--) 
         { 
            if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true)
            { 
               
               if(OrderType() == OP_BUY)  {
               
                  DisplayText("Panel242"+j,OrderSymbol()+"              "+ OrderLots()+"    ", Font, Text_Order_Buy, 0, 13, Font-26 - j * 18, "Tahoma Bold"); 
                  PL = (OrderClosePrice()-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT)/10.0;
                  total = total + PL;
                  if(PL<0) DisplayText("Panel243"+j, DoubleToStr(PL, 0)+"   ", Font, Negative_Font, 0, 50, Font-26 - j * 18, "Tahoma Bold"); 
                  else if(PL>0) DisplayText("Panel243"+j, "+"+DoubleToStr(PL, 0)+"   ", Font, Positive_Font, 0, 50, Font-26 - j * 18, "Tahoma Bold"); 
                  else DisplayText("Panel243"+j, DoubleToStr(PL, 0)+"   ", Font, Warna_Text, 0, 50, Font-26 - j * 18, "Tahoma Bold"); 
               }
               else if(OrderType() == OP_SELL)  {
                  
                  DisplayText("Panel242"+j,OrderSymbol()+"              "+ OrderLots()+"    ", Font, Text_Order_Sell, 0, 13, Font-26 - j * 18, "Tahoma Bold"); 
                  PL = (OrderOpenPrice()-OrderClosePrice())/MarketInfo(OrderSymbol(),MODE_POINT)/10.0;
                  total = total + PL;
                  if(PL<0) DisplayText("Panel243"+j, DoubleToStr(PL, 0)+"   " , Font, Negative_Font, 0, 50, Font-26 - j * 18, "Tahoma Bold"); 
                  else if(PL>0) DisplayText("Panel243"+j,"+"+DoubleToStr(PL, 0)+"   " , Font, Positive_Font, 0, 50, Font-26 - j * 18, "Tahoma Bold"); 
                  else DisplayText("Panel243"+j,DoubleToStr(PL, 0)+"   " , Font, Warna_Text, 0, 50, Font-26 - j * 18, "Tahoma Bold"); 
               }
               j=j+1;
               k=-60;
            } 
         } 
        
         DisplayText("Panel241", "- Open trades -", Font, Warna_Text, 0, 50, Font-30 - j * 18, NamaFont);
         DisplayText("Total1","Total          ", Font, Warna_Text, 0,100, Font-26 - k * 18.767, "Arial");
   
         if(total<0) DisplayText("Total2", DoubleToStr(total, 0)+" pips" , TotalFont, Red, 0, 30, Font-26 - k * 18.7, "Arial");
         else if (total>0) DisplayText("Total2","+" + DoubleToStr(total, 0)+" pips" , TotalFont, LimeGreen, 0, 30, Font-26 - k * 18.7, "Arial");
         else DisplayText("Total2", DoubleToStr(total, 0)+" pips" , TotalFont, White, 0, 30, Font-26 - k * 18.7, "Arial");
                
         x=j;
  
   return(0);
  }
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*                                                         
                                        ud$$$**BILLION$bc.                          
                                    u@**"        PROJECT$$Nu                       
                                  J                ""#$$$$$$r                     
                                 @                       $$$$b                    
                               .F                        ^*3$$$                   
                              :% 4                         J$$$N                  
                              $  :F                       :$$$$$                  
                             4F  9                       J$$$$$$$                 
                             4$   k             4$$$$bed$$$$$$$$$                 
                             $$r  'F            $$$$$$$$$$$$$$$$$r                
                             $$$   b.           $$$$$$$$$$$$$$$$$N                
                             $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
              .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
              :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
             @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
             $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
             $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
              ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
                 ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
                      ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
                        ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                          '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                             #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                               "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                                 "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                                   ?k         ?$$$$$$$$$$$F'*                     
                                    9$$bL     z$$$$$$$$$$$F                       
                                     $$$$    $$$$$$$$$$$$$                        
                                      '#$$c  '$$$$$$$$$"                          
                                       .@"#$$$$$$$$$$$$b                          
                                     z*      $$$$$$$$$$$$N.                       
                                   e"      z$$"  #$$$k  '*$$.                     
                                .u*      u@$P"      '#$$c   "$$c                   
                        u@$*"""       d$$"            "$$$u  ^*$$b.               
                      :$F           J$P"                ^$$$c   '"$$$$$$bL        
                     d$$  ..      @$#                      #$$b         '#$       
                     9$$$$$$b   4$$                          ^$$k         '$      
                      "$$6""$b u$$                             '$    d$$$$$P      
                        '$F $$$$$"                              ^b  ^$$$$b$       
                         '$W$$$$"                                'b@$$$$"         
                                                                  ^$$$*/     